more off;
% Resolution limits for a circle graph

%function o = objective(m, n,roq,which)
	%if m > n || m < 0
		%o = 1e100;
		%return;
	%end
	%k = n/m;
	%nv = m/n;
	%nw = m/n - roq/n;
	%ne = nv - nw;
	%% gradients
	%dk = 1/m;
	%dnv = -m/n^2;
	%dnw = -m/n^2 + roq/n^2;
	%dne = dnv - dnw;
	%% objectives
	%if isequal(which,'mod')
		%o = -k * (nw - nv^2);
		%d = -k * (dnw - 2 * nv * dnv) + -dk * (nw - nv^2);
	%elseif isequal(which,'sld')
		%o = k * (nw * log(nv));
		%d = k * (dnw * log(nv) + nw * dnv/nv) + dk * (nw * log(nv));
	%elseif isequal(which,'dds')
		%o = k * (nw * (nv - 1));
		%d = k * (dnw * (nv - 1) + nw * dnv) + dk * (nw * (nv - 1));
	%elseif isequal(which,'ncut')
		%o = (m-n)^2; % hack
	%elseif isequal(which,'ancut')
		%o = n/m^2 + sqrt(n)*k*nw;
	%elseif isequal(which,'infomap')
		%o = k * ( plogp(nv+ne) - 2 * plogp(ne) ) + plogp(k*ne);
	%else
		%error('unknown objective');
	%end
%end
%function y = plogp(x)
	%y = x*log(x);
%end
%function y = dplogp(x)
	%y = 1 + log(x);
%end
function [ov,od] = objective(m, n,roq,which)
	if m > n || m < 0
		o = ov = 1e100;
		od = inf;
		return;
	end
	m = autodiff(m,1);
	k = n/m;
	nv = m/n;
	nw = m/n - roq/n;
	ne = nv - nw;
	v = m;
	w = m-roq;
	% objectives
	if isequal(which.id,'mod')
		o = -k * (nw - nv^2);
	elseif isequal(which.id,'fmod')
		ntv = which.m; % ??
		o = -k * (nw - nv^2);
	elseif isequal(which.id,'sld')
		o = k * (nw * log(nv));
	elseif isequal(which.id,'dds')
		o = k * (nw * (nv - 1));
	elseif isequal(which.id,'ncut')
		o = (m-n)^2; % hack
	elseif isequal(which.id,'ancut')
		o = n/m^2 + sqrt(n)*k*nw;
	elseif isequal(which.id,'infomap')
		o = k * ( plogp(nv+ne) - 2 * plogp(ne) ) + plogp(k*ne);
	elseif isequal(which.id,'asmod')
		% adaptive scale modularity
		ntv = which.m; % ??
		o = -k * (nw/(ntv+2*nv) - (nv/(ntv+2*nv))^2);
	elseif isequal(which.id,'fasmod')
		% adaptive scale modularity
		tv = which.m; % ??
		o = -k * (w/(tv+2*v) - (v/(tv+2*v))^2);
	else
		error('unknown objective');
	end
	ov = val(o); od = diff(o);
	%ov=o;od=0;
end
function y = plogp(x)
	y = x*log(x);
end

% oops, not the thing that I want
function [fv,x] = newton(f,x,varargin)
	fv = 0; fd = 1;
	for it=1:10
		x = x - fv/fd
		[fv,fd] = f(x,varargin{:})
		if abs(fd) < 1e-6, break; end
	end
end
function [m,fvm] = bisect(f,a,b,varargin)
	% Bisection search to find x, a<=x<=b where f(x) = 0
	[_,fda] = f(a,varargin{:});
	[_,fdb] = f(b,varargin{:});
	if sign(fda) == sign(fdb)
		warning("can't use bisection");
		m = (a+b)/2;
		fvm = f(m,varargin{:});
		return;
	end
	for it=1:50
		m = (a+b)/2;
		[fvm,fdm] = f(m,varargin{:});
		if sign(fda) == sign(fdm)
			a = m; fda = fdm;
		else
			b = m; fdb = fdm;
		end
	end
end

%return;

objectives = {};
objectives{end+1} = struct('id','ncut', 'label','ncut');
objectives{end+1} = struct('id','mod', 'label','modularity');
objectives{end+1} = struct('id','sld', 'label','w-log-v');
%objectives{end+1} = struct('id','dds', 'label','parabola');
objectives{end+1} = struct('id','infomap', 'label','infomap');
objectives{end+1} = struct('id','asmod', 'm',1e3,  'label','a.s.mod:e3');
objectives{end+1} = struct('id','asmod', 'm',1e2,  'label','a.s.mod:e2');
objectives{end+1} = struct('id','asmod', 'm',1e1,  'label','a.s.mod:e1');
objectives{end+1} = struct('id','asmod', 'm',1e0,  'label','a.s.mod:e0');
objectives{end+1} = struct('id','asmod', 'm',1e-1, 'label','a.s.mod:e-1');
objectives{end+1} = struct('id','asmod', 'm',1e-2, 'label','a.s.mod:e-2');
objectives{end+1} = struct('id','asmod', 'm',1e-3, 'label','a.s.mod:e-3');
objectives{end+1} = struct('id','asmod', 'm',0,    'label','a.s.mod:0');

objectives{end+1} = struct('id','fasmod', 'm',1e3,  'label','fa.s.mod:e3');
objectives{end+1} = struct('id','fasmod', 'm',1e2,  'label','fa.s.mod:e2');
objectives{end+1} = struct('id','fasmod', 'm',1e1,  'label','fa.s.mod:e1');
objectives{end+1} = struct('id','fasmod', 'm',1e0,  'label','fa.s.mod:e0');
objectives{end+1} = struct('id','fasmod', 'm',1e-1, 'label','fa.s.mod:e-1');
objectives{end+1} = struct('id','fasmod', 'm',1e-2, 'label','fa.s.mod:e-2');
objectives{end+1} = struct('id','fasmod', 'm',1e-3, 'label','fa.s.mod:e-3');

save = 0;
if save
	r=1;
	for q=[1,10,4*5/2+1,5*6/2+1,45,9*10/2+1,50,100]
		%r = 1; q = 10;
		%r = 1; q = 100;
		roq = r/q;

		file = fopen(sprintf('../../paper/graph-resolution-limits-r=%d,q=%d.tex',r,q),'wt');
		for o = 1:numel(objectives)
			fprintf(file,'\\addplot[plot style %s] coordinates{\n', objectives{o}.label);
			for ln = 1:0.2:6
				n=10^ln;
				opts = struct();
				%opts.numDiff = true;
				opts.DerivativeCheck = true;
				%opts.Display = 'off';
				%opts.Method = 'sd';
				opts.TolFun = 1e-10;
				%m = minFunc(@objective,sqrt(n),opts, n,roq,objectives{o});
				m = bisect(@objective,1e-10,n, n,roq,objectives{o});
				
				fprintf(file,' (%f,%f)\n', n,m);
			end
			fprintf(file,'}; \\addlegendentry{%s}\n', objectives{o}.label);
		end
		fclose(file);
	end


	file = fopen('../../paper/graph-resolution-limits-roq.tex','wt');
	for o = 2:numel(objectives)
		fprintf(file,'\\addplot+[] coordinates{\n');
		for roq = 0.05:0.05:1
			n=1000;
			opts = struct();
			opts.numDiff = true;
			opts.Display = 'off';
			m = minFunc(@objective,1,opts, n/roq,roq,objectives{o});
			
			fprintf(file,' (%f,%f)\n', roq,m);
		end
		fprintf(file,'}; \\addlegendentry{%s}\n', objectives{o}.label);
	end
	fclose(file);
	
else
	r=1; q = 100;
	roq = r/q;
	%lns = 1:0.2:6;
	lns = 1:0.5:6;
	ns = 10 .^ lns;
	ms = [];
	for o = 1:numel(objectives)
		for in = 1:numel(ns)
			n = ns(in);
			ms(o,in) = bisect(@objective,1e-10,n, n,roq,objectives{o});
			fprintf(stderr,'.');fflush(stderr);
		end
		fprintf(stderr,'\n');fflush(stderr);
	end
	
	plot(log10(ns),log10(ms),'-o','markersize',2);
	legend(cellfun(@(x)x.label,objectives,'UniformOutput',false));
end
